package Scorch.sWindows;

/*
  Class:  Inventory
  Author: Mikhail Kruk
  Desciption: Shows the list of weapons and items and allows to select 
  and activate them
*/

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import Scorch.*;
import Scorch.Weapons.*;
import Scorch.Items.*;

public class Inventory extends sWindow implements ActionListener
{
    protected ScorchPlayer myPlayer;

    public Inventory(ScorchApplet owner)
    {
	super(0,0,0,0,"Inventory", owner);
   
	myPlayer = owner.getMyPlayer();

	Vector weapons = myPlayer.getWeapons();
	Vector items = myPlayer.getItems();
	Vector panels = new Vector();
	int count = 0;

	loadPanels(panels, weapons);
	loadPanels(panels, items);
	
	count = panels.size();

	/*Panel p = new Panel(new GridLayout(count,1,0,0)), 
	    b = new Panel(new FlowLayout(FlowLayout.CENTER));

	    p.setBackground(Color.gray);*/

	/*for(int i = 0; i < count; i++)
	  p.add((Panel)panels.elementAt(i));*/

	/*sPanel spnl = new sPanel(-1,-1);
	  spnl.add(p);*/

	Panel b = new Panel(new FlowLayout(FlowLayout.CENTER));
	Button bOK = new Button("OK");
	b.add(bOK);
	
	bOK.addActionListener(this);

	// take max number of rows we can display
	// assume that Inventory box should be <= 50% of the applet
	int rows = (int)(owner.getHeight()*0.5) / 
	    ((Component)panels.elementAt(0)).getPreferredSize().height;

	sScrollPanel scp = new sScrollPanel(this, -1, -1, panels, rows);

	setLayout(new BorderLayout(0,0));
	//add(spnl,BorderLayout.CENTER);
	add(scp,BorderLayout.CENTER);
	add(b, BorderLayout.SOUTH);
    }

    // build a list of panels which correspond to items vector
    private void loadPanels(Vector panels, Vector items)
    {
	for(int i = 0; items != null && i < items.size(); i++)
	    {
		Panel pp = new Panel(new GridLayout(1,3,0,0));
		Item item = (Item)items.elementAt(i);
		
		if( item.getQuantity() == 0 )
		    continue;
		
		pp.add(new Label(item.getName(), Label.CENTER));
		pp.add(item.getQuantityLabel());
		pp.add(item.getControlPanel((ScorchApplet)owner));
		panels.addElement(pp);
	    }
    }
    
    public void close()
    {
	super.close();
	transferFocus();
    }

    public void actionPerformed(ActionEvent evt)
    {
	close();
	return;
    }
}
