package Scorch.sWindows;

/*
  Class:  PlayersList
  Author: Mikhail Kruk
  Description: extension of the PlayersLister interface that stores 
  players in the List java GUI element
*/

import java.awt.*;

import Scorch.*;

public class PlayersList extends sWindow implements PlayersLister
{
    // max [displayed] length of username 
    protected static final int MAX_LENGTH = 20; 

    protected List players;

    public PlayersList(String name, ScorchApplet owner)
    {
	super(0,0,0,0,name, owner);
	
	players = new List(ScorchPlayer.MAX_PLAYERS);
    }

    public void addPlayer(String name)
    {
	players.add(name.substring(0,Math.min(MAX_LENGTH,name.length())));
    }

    public void removePlayer(String name)
    {
	players.remove(name.substring(0,Math.min(MAX_LENGTH,name.length())));
    }

}
